/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Departemen;
import com.portofolio.entity.vo.DepartemenId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface DepartemenMasterDao extends CrudRepository<Departemen, DepartemenId> {

	@Cacheable("DepartemenDaofindOneBy")
	Departemen findOneByIdKodeAndIdKdProfile(String kode, Integer kdProfile);

	@Query(QListAll)
	@Cacheable("DepartemenDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page);

	@Query(QListAll + " and model.namaDepartemen like %:namaDepartemen% ")
	@Cacheable("DepartemenDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaDepartemen") String namaDepartemen, Pageable page);

	@Query(QListAll + " and model.id.kode = :kode")
	@Cacheable("DepartemenDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") String kode);


	String QListAll = "select new map(model.id.kdDepartemen as kdDepartemen,model.id.kdProfile as kdProfile " 
			+ ", model.reportDisplay as reportDisplay "
			+ ", model.kdPegawaiKepala as kdPegawaiKepala "
			+ ", pegawai.namaLengkap as namaLengkap " 
			+ ", model.kdDepartemenHead as kdDepartemenHead " 
			+ ", departemenHead.namaDepartemen as namaDepartemenHead "
			+ ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " 
			+ ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec "
			+ ", model.namaDepartemen as namaDepartemen, model.version as version )" + " from Departemen model "
			+ " left join Departemen departemenHead on departemenHead.id.kode=model.kdDepartemenHead and departemenHead.id.kdProfile=model.id.kdProfile " 
			+ " left join Pegawai pegawai on pegawai.id.kode=model.kdPegawaiKepala and  pegawai.id.kdProfile=model.id.kdProfile "
			+ " where model.id.kode=:kdProfile ";

}
